import swarm.SignatureNotFoundException;
import swarm.NonUniqueMethodSignatureException;
import swarm.Globals;
import swarm.Selector;
import swarm.defobj.Zone;
import swarm.defobj.SymbolImpl;
import swarm.defobj.FArguments;
import swarm.defobj.FArgumentsImpl;
import swarm.defobj.FCall;
import swarm.defobj.FCallImpl;
import swarm.activity.Activity;
import swarm.activity.ActionGroup;
import swarm.activity.ActionGroupImpl;
import swarm.activity.Schedule;
import swarm.activity.ScheduleImpl;
import swarm.activity.ActionForEach;
import swarm.objectbase.Swarm;
import swarm.objectbase.SwarmImpl;
import swarm.objectbase.VarProbe;
import swarm.objectbase.MessageProbe;
import swarm.objectbase.EmptyProbeMapImpl;
import java.util.*;
import swarm.space.Grid2d;
import swarm.space.Grid2dImpl;
import swarm.random.NormalDistImpl;
import java.io.*;
public class GroupModelSwarm extends SwarmImpl
{
  public ActionGroup modelActions;
  public Schedule modelSchedule;
  public List leaderList;
 public List leader1List;
  public int worldXSize=80;
  public int worldYSize=80;
  public int GroupSize=8;
  public int NoofLeaders=1;
  public int NoofFollowers=7;
  public Grid2dImpl world;
  ActionForEach[] actionForEach = new ActionForEach[4];
  public List getLeaderList () {
    return leaderList;
  }


  public Grid2d getWorld () {
    return world;
  }
 public List getLeader1List()
  {
        return leader1List;
  }

  public GroupModelSwarm (Zone aZone) {
    super (aZone);

    class GroupModelProbeMap extends EmptyProbeMapImpl {
      private VarProbe probeVariable (String name) {
        return
          Globals.env.probeLibrary.getProbeForVariable$inClass
          (name, GroupModelSwarm.this.getClass ());
      }
      private MessageProbe probeMessage (String name) {
        return
          Globals.env.probeLibrary.getProbeForMessage$inClass
          (name, GroupModelSwarm.this.getClass ());
      }
      private void addVar (String name) {
        addProbe (probeVariable (name));
      }
      private void addMessage (String name) {
        addProbe (probeMessage (name));
      }
      public GroupModelProbeMap(Zone _aZone, Class aClass) {
        super (_aZone, aClass);
	   addVar ("worldXSize");
                                addVar ("worldYSize");
                                addVar("GroupSize");
                                addVar ("NoofLeaders");
                                addVar("NoofFollowers");



      }
    }

    Globals.env.probeLibrary.setProbeMap$For
      (new GroupModelProbeMap (aZone, getClass ()), getClass ());
  }

  public Object buildObjects ()
  {
    super.buildObjects();

 int dim=4;
        int dim1=8;
    worldXSize = 80;
    worldYSize = 80;

    world = new Grid2dImpl (getZone (), worldXSize, worldYSize);

    leaderList = new LinkedList ();
   leader1List = new LinkedList();

    world.setOverwriteWarnings(false);
//MainApp l;
       MyMathsClass mmc;
     Leader l1;
      //  l =  new MainApp();
       mmc = new MyMathsClass();
      //leaderList.add (l);
        leaderList.add(mmc);
        int x=4;
        int y=4;
        for(int i=0;i<dim;i++){
                x=8;
                for(int j=0;j<dim1;j++)
        {
         l1=new Leader(world);
         leader1List.add(l1);
        l1.setX$Y(x,y);
world.putObject$atX$Y(l1, x, y);
        x=x+4;
        }
        y=y+8;
}


   

    world.setOverwriteWarnings(true);
    return this;
  }


  public Object buildActions () {

    super.buildActions();

    modelActions = new ActionGroupImpl (getZone ());

try {
    //  MainApp protoLeader = (MainApp) leaderList.get (0);
        MyMathsClass protoLeader = (MyMathsClass) leaderList.get(0);
      Selector sel1 = new Selector (protoLeader.getClass (), "addEmUp", false);
      actionForEach[1] = modelActions.createActionForEach$message(leaderList, 
sel1);

    } 
	 catch (SignatureNotFoundException e) {
        e.printStackTrace();
 //    e.printStackTrace (System.err);
        System.out.println("Exception has occured here signature");
        //System.exit(1);  
}
		catch(Exception e1)
	{
	e1.printStackTrace();
	}
	/*catch (SignatureNotFoundException e) {
	e.printStackTrace();
     // e.printStackTrace (System.err);
        System.out.println("Exception has occured here");
        //System.exit(1);*/
   
    modelSchedule = new ScheduleImpl (getZone (), 1);
    modelSchedule.at$createAction (0, modelActions);

    return this;
  }

  public Activity activateIn (Swarm swarmContext) {

    super.activateIn (swarmContext);

    modelSchedule.activateIn (this);

    return getActivity ();
  }

}



























